Subject: Emacs master doesn't build if !HAVE_TREE_SITTER

From: Paul Eggert <[email-masked]>
Date: Thu, 29 Dec 2022 20:46:32 -0800

On my platform the current Emacs master (commit 
91ae9f3d12885373d38c3e8d693f7dc210f9d471) won't build, failing with:

   ELC      progmodes/typescript-ts-mode.elc

In toplevel form:
progmodes/typescript-ts-mode.el:31:2: Error: Symbol’s function 
definition is vo\
id: treesit-query-compile

Full log (compressed) attached, built from Git on Fedora 37 x86-64. The 
best fix isn't immediately obvious to me; adding a declare-function 
doesn't work.

This platform doesn't have the tree-sitter library, so HAVE_TREE_SITTER 
is not defined which means C doesn't define treesit-query-compile.

I will probably just install the tree-sitter library to work around the 
bug, but thought I'd document it. Presumably you can simulate it by 
configuring --without-tree-sitter.